#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <multicolors>
#include <autoexecconfig>
#include <emperor>
#include <cstrike>

#define DEBUG

#pragma semicolon 1
#pragma newdecls required

bool OnlyHeadShot = true;
bool AntiSpam = true;
bool Deagle1 = true;

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_DisableDeagle_Message;
ConVar gConVar_EnableDeagle_Message;
ConVar gConVar_OnOnlyHeadShot_Message;
ConVar gConVar_OffOnlyHeadShot_Message;
ConVar gConVar_OnAntiSpam_Message;
ConVar gConVar_OffAntiSpam_Message;

ConVar gConVar_JoinStaffMsg;

//Disable Deagle

#define NAME_LENGTH 64

ArrayList g_alRestrictedWeapons = null;

bool g_bLateLoaded = false;

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	g_bLateLoaded = late;
}


/////////////////////////////////////////////////////////////////////////////////////////////////
// Credits for:
// Simple Weapon Restrictor - https://forums.alliedmods.net/showthread.php?p=2429066 - By N1ckles
//
// Dependencies are Required:
// Anti Deagle Spam - https://github.com/Xurape/Anti-Deagle-Spray by SHUT UP
// Deagle HS Only - https://forums.alliedmods.net/showthread.php?t=331188 by Spirt
/////////////////////////////////////////////////////////////////////////////////////////////////


public Plugin myinfo = 
{
	name = "Deagle Modes", 
	author = "LanteJoula", 
	description = "Deagle Modes", 
	version = "1.0", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

public void OnPluginStart()
{
	LoadTranslations("deaglemodes.phrases");
	
	AutoExecConfig_SetFile("plugin.deaglemodes");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("a_chat_prefix", "{green}[ TAG ]{default}", "Chat Prefix");
	
	gConVar_DisableDeagle_Message = AutoExecConfig_CreateConVar("sm_deagle_onlyhead_shot_message", "1", "Enable/Disable the Fake Join Staff Message (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_EnableDeagle_Message = AutoExecConfig_CreateConVar("sm_deagle_full_all_body_message", "1", "Enable/Disable the Fake Leave Staff Message (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_OnOnlyHeadShot_Message = AutoExecConfig_CreateConVar("sm_deagle_onlyhead_shot_message", "1", "Enable/Disable the Fake Join Staff Message (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_OffOnlyHeadShot_Message = AutoExecConfig_CreateConVar("sm_deagle_full_all_body_message", "1", "Enable/Disable the Fake Leave Staff Message (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_OnAntiSpam_Message = AutoExecConfig_CreateConVar("sm_deagle_anti_spam_message", "1", "Enable/Disable the Join Staff Mode (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_OffAntiSpam_Message = AutoExecConfig_CreateConVar("sm_deagle_spam_message", "1", "Enable/Disable the Leave Staff Mode (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_JoinStaffMsg = AutoExecConfig_CreateConVar("z_joinstaff_message", "1", "Enable/Disable the Message when Staff Join on Server (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	RegAdminCmd("sm_deagle", Deagle, ADMFLAG_GENERIC);
	
	
	//Disable Deagle
	g_alRestrictedWeapons = new ArrayList(ByteCountToCells(NAME_LENGTH));
	
	RegAdminCmd("sm_deaglerestrict1", Command_Restrict, ADMFLAG_GENERIC, "Restricts a weapon.");
	RegAdminCmd("sm_deagleunrestrict1", Command_Unrestrict, ADMFLAG_GENERIC, "Unestricts a weapon.");
	
	if (g_bLateLoaded)
	{
		for (int client = 1; client < MaxClients; ++client)
		{
			if (IsClientInGame(client)) {
				OnClientPutInServer(client);
			}
		}
	}
	
	//GIVE DEAGLE
	HookEvent("round_start", OnRoundStart);
}

public void SavePrefix()
{
	char cBuffer[256];
	GetConVarString(gConVar_Chat_Prefix, EMP_STRING(cBuffer));
	FormatEx(EMP_STRING(g_ChatPrefix), "%s ", cBuffer);
	EMP_ProcessColors(EMP_STRING(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

public void OnClientPutInServer(int client)
{
	//JoinMsg
	CreateTimer(5.4, JoinMsgStaff, client);
	
	//Disable Deagle
	SDKHook(client, SDKHook_WeaponEquip, Event_WeaponEquip);
}

//JoinMsg

public Action JoinMsgStaff(Handle timer, any client)
{
	if (CheckCommandAccess(client, "sm_override_staff", ADMFLAG_GENERIC))
	{
		if (gConVar_JoinStaffMsg.BoolValue)
			CPrintToChat(client, "%s %t", g_ChatPrefix, "JoinMsg");
	}
}

//////////////
// Deagle Menu
//////////////

public Action Deagle(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	char DeagleMenu1[128];
	char DisableDeagleMenu1[128];
	char EnableDeagleMenu1[128];
	
	char OnlyHeadShotMenu1[128];
	char OffOnlyHeadMenu1[128];
	char OnOnlyHeadMenu1[128];
	
	char AntiSpamMenu1[128];
	char OnAntiSpamMenu1[128];
	char OffAntiSpamMenu1[128];
	
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("%t", "DeagleModesMenuTitle");
	Format(DeagleMenu1, sizeof(DeagleMenu1), "%t", "DeagleMenu");
	menu.AddItem("space1", DeagleMenu1, ITEMDRAW_DISABLED);
	if (!Deagle1)
	{
		Format(EnableDeagleMenu1, sizeof(EnableDeagleMenu1), "%t", "EnableDeagleMenu");
		menu.AddItem("1", EnableDeagleMenu1);
	}
	else
	{
		Format(DisableDeagleMenu1, sizeof(DisableDeagleMenu1), "%t", "DisableDeagleMenu");
		menu.AddItem("2", DisableDeagleMenu1);
	}
	Format(OnlyHeadShotMenu1, sizeof(OnlyHeadShotMenu1), "%t", "OnlyHeadShotMenu");
	menu.AddItem("space2", OnlyHeadShotMenu1, ITEMDRAW_DISABLED);
	if (!OnlyHeadShot)
	{
		Format(OnOnlyHeadMenu1, sizeof(OnOnlyHeadMenu1), "%t", "OnOnlyHeadMenu");
		menu.AddItem("3", OnOnlyHeadMenu1);
	}
	else
	{
		Format(OffOnlyHeadMenu1, sizeof(OffOnlyHeadMenu1), "%t", "OffOnlyHeadMenu");
		menu.AddItem("4", OffOnlyHeadMenu1);
	}
	Format(AntiSpamMenu1, sizeof(AntiSpamMenu1), "%t", "AntiSpamMenu");
	menu.AddItem("space3", AntiSpamMenu1, ITEMDRAW_DISABLED);
	if (!AntiSpam)
	{
		Format(OnAntiSpamMenu1, sizeof(OnAntiSpamMenu1), "%t", "OnAntiSpamMenu");
		menu.AddItem("5", OnAntiSpamMenu1);
	}
	else
	{
		Format(OffAntiSpamMenu1, sizeof(OffAntiSpamMenu1), "%t", "OffAntiSpamMenu");
		menu.AddItem("6", OffAntiSpamMenu1);
	}
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		if (StrEqual(selectedItem, "1"))
		{
			Deagle1 = true;
			
			FakeClientCommand(client, "sm_deagleunrestrict1 deagle");
			
			char name[128];
			int Secondary = GetPlayerWeaponSlot(client, CS_SLOT_SECONDARY);
			if (Secondary != -1)
			{
				if (!StrEqual(name, "weapon_deagle"))
				{
					RemovePlayerItem(client, Secondary);
					GivePlayerItem(client, "weapon_deagle");
				}
			}
			else
			{
				GivePlayerItem(client, "weapon_deagle");
			}
			
			if (gConVar_EnableDeagle_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "EnableDeagle");
		}
		if (StrEqual(selectedItem, "2"))
		{
			Deagle1 = false;
			
			FakeClientCommand(client, "sm_deaglerestrict1 deagle");
			
			if (gConVar_DisableDeagle_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "DisableDeagle");
		}
		if (StrEqual(selectedItem, "3"))
		{
			OnlyHeadShot = true;
			
			ServerCommand("sm plugins load spirt_deaglehs");
			
			if (gConVar_OnOnlyHeadShot_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OnOnlyHead");
		}
		if (StrEqual(selectedItem, "4"))
		{
			OnlyHeadShot = false;
			
			ServerCommand("sm plugins unload spirt_deaglehs");
			
			if (gConVar_OffOnlyHeadShot_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OffOnlyHead");
		}
		if (StrEqual(selectedItem, "5"))
		{
			AntiSpam = true;
			
			ServerCommand("sm plugins load anti-deagle-spam");
			
			if (gConVar_OnAntiSpam_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OnAntiSpam");
		}
		if (StrEqual(selectedItem, "6"))
		{
			AntiSpam = false;
			
			ServerCommand("sm plugins unload anti-deagle-spam");
			
			if (gConVar_OffAntiSpam_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OffAntiSpam");
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}



//Disable Deagle

public Action Event_WeaponEquip(int client, int weapon)
{
	char weaponClass[NAME_LENGTH];
	GetEdictClassname(weapon, weaponClass, sizeof(weaponClass));
	
	StripWeaponPrefix(weaponClass, sizeof(weaponClass));
	
	if (g_alRestrictedWeapons.FindString(weaponClass) != -1)
	{
		AcceptEntityInput(weapon, "kill");
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

public Action Command_Restrict(int client, int args)
{
	char weaponAlias[NAME_LENGTH];
	GetCmdArg(1, weaponAlias, sizeof(weaponAlias));
	
	StripWeaponPrefix(weaponAlias, sizeof(weaponAlias));
	
	LowerCaseString(weaponAlias);
	
	if (g_alRestrictedWeapons.FindString(weaponAlias) != -1)
	{
		return Plugin_Handled;
	}
	
	g_alRestrictedWeapons.PushString(weaponAlias);
	
	RemoveWeaponFromAllPlayer(weaponAlias);
	
	return Plugin_Handled;
}

public Action Command_Unrestrict(int client, int args)
{
	char weaponAlias[NAME_LENGTH];
	GetCmdArg(1, weaponAlias, sizeof(weaponAlias));
	
	StripWeaponPrefix(weaponAlias, sizeof(weaponAlias));
	
	LowerCaseString(weaponAlias);
	
	int index = g_alRestrictedWeapons.FindString(weaponAlias);
	if (index == -1)
	{
		return Plugin_Handled;
	}
	
	g_alRestrictedWeapons.Erase(index);
	
	return Plugin_Handled;
}

void RemoveWeaponFromAllPlayer(const char[] weaponAlias)
{
	char weaponClass[NAME_LENGTH];
	Format(weaponClass, sizeof(weaponClass), "weapon_%s", weaponAlias);
	
	for (int client = 1; client < MaxClients; ++client)
	{
		if (!IsClientInGame(client))
		{
			continue;
		}
		
		for (int slot = CS_SLOT_PRIMARY; slot <= CS_SLOT_C4; ++slot)
		{
			
			int weapon = GetPlayerWeaponSlot(client, slot);
			
			if (weapon == -1)
			{
				continue;
			}
			
			char entityClass[NAME_LENGTH];
			GetEdictClassname(weapon, entityClass, sizeof(entityClass));
			
			if (StrEqual(weaponClass, entityClass, true))
			{
				if (RemovePlayerItem(client, weapon))
				{
					AcceptEntityInput(weapon, "kill");
				}
				break;
			}
		}
	}
}

void StripWeaponPrefix(char[] weapon, int size)
{
	ReplaceString(weapon, size, "weapon_", "", false);
}

void LowerCaseString(char[] s)
{
	for (int i = 0; ; ++i)
	{
		if (s[i] == '\0')
		{
			break;
		}
		
		if (IsCharUpper(s[i]))
		{
			s[i] = CharToLower(s[i]);
		}
	}
}


//GIVE DEAGLE

public Action OnRoundStart(Event event, const char[] name, bool dontBroadcast)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))continue;
		int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
		
		if (Secondary != -1)
		{
			if (!StrEqual(name, "weapon_deagle"))
			{
				RemovePlayerItem(i, Secondary);
				GivePlayerItem(i, "weapon_deagle");
			}
		}
		else
		{
			GivePlayerItem(i, "weapon_deagle");
		}
	}
} 